@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
if not exist "%0" perl    -x "%0.bat" %1 %2 %3 %4 %5 %6 %7 %8 %9
if exist "%0" perl    -x "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
if not exist "%0" perl    -x "%0.bat" %*
if exist "%0" perl -x "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\\system32\\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl and onestep.bat in your current directory.
if errorlevel 1 goto script_failed_so_exit_with_non_zero_val 2>nul
goto endofperl
@rem ';
#!perl -w
#line 17

# Note:
# PAX is shipped with Windows NT
# http://support.microsoft.com/support/kb/articles/Q104/4/91.asp
#


# turn on warnings
$^W = 1;


# where files are located for "Bugzilla One Step Install"
$BUGZILLA_INSTALL="bugzilla_install";

# where tars are kept after fetching them
$BUGZILLA_TARS="bugzilla_tars";

# A listing of DOS drive letters to search for the above directories
@ALPHABET_SOUP=(
#   'Z:', 'Y:', 'X:', 'W:', 'V:', 'U:', 'T:', 'S:', 'R:', 'Q:',
#   'P:', 'O:', 'N:', 'M:', 'L:', 'K:', 'J:', 'I:', 'H:',
    'G:', 'F:', 'E:', 'D:', 'C:');

# What is the directory name where bugzilla files will be stored?
# Don't put any slashes in this name, just use bugzilla or bugzilla-2.14 or something
$BUGZILLA_FILES="bugzilla";

# The version number on the bugzilla tar,
# e.g. use 2.14 for bugzilla-2.14.tar.gz
# also the version number on the directory after the tar expands, e.g. bugzilla-2.14
$BUGZILLA_VER = "2.17.4";
$BUGZILLA_VER = "2.14.5";


# These are the bugs with 2.17.4
# These are the bugs with 2.17.4
# These are the bugs with 2.17.4

#Found = in conditional, should be == at checksetup.pl line 1144.
#
#Checking perl modules ...
#Checking for       AppConfig (v1.52)   ok: found v1.52
#Checking for             CGI (v2.88)    found v2.86
#Checking for    Data::Dumper (any)     ok: found v2.102
#Checking for    Date::Format (v2.21)   ok: found v2.22
#Checking for             DBI (v1.32)   ok: found v1.35
#Checking for      DBD::mysql (v2.1010) ok: found v2.1026
#Checking for      File::Spec (v0.82)   ok: found v0.82
#Checking for      File::Temp (any)     ok: found v0.12
#Checking for        Template (v2.08)   ok: found v2.08
#Checking for      Text::Wrap (v2001.0131) ok: found v2001.0929
#
#The following Perl modules are optional:
#Checking for              GD (v1.20)   ok: found v2.07
#Checking for     Chart::Base (v0.99)    found unknown version
#Checking for     XML::Parser (any)     ok: found v2.31
#Checking for       GD::Graph (any)     ok: found v1.35
#Checking for GD::Text::Align (any)     ok: found v1
#
#If you you want to see graphical bug charts (plotting historical data over
#time), you should install libgd and the following Perl modules:
#
#Chart 0.99b: perl -MCPAN -e'install "N/NI/NINJAZ/Chart-0.99b.tar.gz"'



#<justdave> 2.17.4 would be easier to hack for Windows than 2.16.3 would be
#<stosh> I'm using 2.14.5 :-)
#<justdave> 2.14.5 has unfixed security holes.
#<justdave> and it's not supported. :)
#<stosh> Guess I'll step up sooner rather than later ...
#<justdave> 2.17.4 would probably be about equivalent to 2.14.5, if not a hair easier, for hacking for Win32
#<justdave> we broke a bunch of things on Win32 in 2.16
#<justdave> I think the only major thing you have to do is hack it to send mail an alternate way
#<stosh> (Yes, I saw notes about the breakage.  That's one reason I was waiting to upgrade.)
#<stosh> I don't intend to test the mail subsystem for a while.
#<justdave> there's a couple of minor things left, like duplicates.cgi being shelled to from collectstats.pl and system() being broken in taint mode on Win32, etc
#<justdave> password prompt doesn't work from checksetup.pl when creating the admin account...
#<justdave> little things like that



# infozip version
# This is the filename of the version of infozip to use
#
# (This was 542. I've updated it to 550)
$INFOZIP_ARCHIVE = "unz550xN.exe";

#
# This is the version of the self-extracting exe to download from
#  theoryx5.uwinnipeg.ca
$UWINNIPEG_ARCHIVE = "perl-win32-bin-0.9.exe";

#
# This is the version of the self-extracting exe to download
# ftp://tug.ctan.org/tex-archive/tools/zip/info-zip/MSDOS/gzip124.exe
#
$GUNZIP_ARCHIVE = "gzip124.exe";

#
# This is the version of the mysql database
# .42 is good, .56 is new
#
$MYSQL_ARCHIVE = "mysql-3.23.42-win.zip";





##############################################################################
sub preliminary_work()
{

    # Let's search for the location of the bugzilla install files.
    # This would be the directory where this batch file is executing.
    $INSDRIVE="";
    foreach $item (@ALPHABET_SOUP)
    {
        $INSDRIVE=$item if ( -d "$item\\$BUGZILLA_INSTALL\\");
    }

    if ("$INSDRIVE" eq "")
    {
        print "Can't find \\bugzilla_install in the root of a drive.\n";
        print LOGFILE "Can't find \\bugzilla_install in the root of a drive.\n";
        exit;
    }

    $BUGZILLA_INSTALL_F="$INSDRIVE\\$BUGZILLA_INSTALL";
    $batch = "$BUGZILLA_INSTALL_F\\temp.bat";







    # Move old log files to the side and start a new log file.
    $FILE="$BUGZILLA_INSTALL_F\\install.log";
    rename ("$FILE", "install.old.log") if (-f "$FILE");

    unlink ($FILE) if (-f "$FILE");


    open LOGFILE, ">>", $FILE;
    print "Info: Logging work to $FILE\n";
    print LOGFILE "Info: Logging work to $FILE\n";

    print "Info: Found Bugzilla install at $BUGZILLA_INSTALL_F\n";
    print LOGFILE "Info: Found Bugzilla install at $BUGZILLA_INSTALL_F\n";






    # Find a drive that already has the files.  Default to C:
    $TARGETDRIVE="C:";
    foreach $item (@ALPHABET_SOUP)
    {
       $TARGETDRIVE=$item if (-d "$item\\perl\\");
    }

    print "Info: Found Bugzilla target drive at $TARGETDRIVE\n";
    print LOGFILE "Info: Found Bugzilla target drive at $TARGETDRIVE\n";






    # Let's find the location of the bugzilla tars, if it already exists.
    $TARDRIVE="";
    foreach $item (@ALPHABET_SOUP)
    {
        $TARDRIVE=$item if (-d "$item\\$BUGZILLA_TARS\\");
    }
    if ("$TARDRIVE" eq "")
    {
        # Can't find it -- default to making it on the following drive.
        $TARDRIVE="C:";
        print "Info: mkdir $TARDRIVE\\$BUGZILLA_TARS\n";
        print LOGFILE "Info: mkdir $TARDRIVE\\$BUGZILLA_TARS\n";
        mkdir "$TARDRIVE\\$BUGZILLA_TARS";
    }

    $BUGZILLA_TARS_F="$TARDRIVE\\$BUGZILLA_TARS";
    print "Info: Found Bugzilla tars at $BUGZILLA_TARS_F\n";
    print LOGFILE "Info: Found Bugzilla tars at $BUGZILLA_TARS_F\n";
}
##############################################################################





##############################################################################
sub ftpget($$$)
{
    my ($ftpsite, $directory, $filename);
    $ftpsite = shift;
    $directory = shift;
    $filename = shift;

    unlink("$BUGZILLA_INSTALL_F\\ftpget.txt") if (-f "$BUGZILLA_INSTALL_F\\ftpget.txt");

    open FTP_SCRIPT_FILE, ">$BUGZILLA_INSTALL_F\\ftpget.txt" or die "Can't open $BUGZILLA_INSTALL_F\\ftpget.txt";
    print FTP_SCRIPT_FILE "user anonymous nobody\@mozilla.org\n";
    print FTP_SCRIPT_FILE "binary\n";
    print FTP_SCRIPT_FILE "cd $directory\n";
    print FTP_SCRIPT_FILE "dir\n";
    print FTP_SCRIPT_FILE "get $filename\n";
    print FTP_SCRIPT_FILE "quit\n";
    close FTP_SCRIPT_FILE;


    print LOGFILE "\n---------------- start of FTP transaction  ----------------\n";
    open(LIST, "ftp -n -s:$BUGZILLA_INSTALL_F\\ftpget.txt $ftpsite |") or die "can't ftp";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of FTP transaction  ----------------\n\n";



    unlink("$BUGZILLA_INSTALL_F\\ftpget.txt") if (-f "$BUGZILLA_INSTALL_F\\ftpget.txt");

    if (-f "$filename")
    {
        print LOGFILE "---------------- start of copy transaction  ----------------\n";
        open(LIST, "copy $filename $BUGZILLA_TARS_F\\$filename | ") or die "can't copy a file";
        my ($textline);
        while (defined($textline = <LIST>))
        {
            print LOGFILE "\t$textline";
        }
        close(LIST);
        print LOGFILE "---------------- end of copy transaction  ----------------\n";

        unlink($filename);
    }
    else
    {
        print "Warning, Couldn't get $filename from $ftpsite with FTP" . ".\n";
        print LOGFILE "Warning, Couldn't get $filename from $ftpsite with FTP" . ".\n";
    }

}
##############################################################################






##############################################################################
sub download_infozip()
{
    # ftp.uu.net /pub/achiving/zip/win32/ $INFOZIP_ARCHIVE
    # ftp://ftp.th-soft.com/UNZIP.EXE
    # ftp://ftp.info-zip.org/pub/infozip/WIN32/
    print "Info: Don't see $BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE\n";
    print "Info: Downloading unzip.exe with FTP\n";
    print LOGFILE "Info: Don't see $BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE\n";
    print LOGFILE "Info: Downloading unzip.exe with FTP\n";

    ftpget("ftp.info-zip.org", "/pub/infozip/WIN32", "$INFOZIP_ARCHIVE");
    if (! -f "$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE")
    {
        ftpget("ftp.uu.net", "/pub/achiving/zip/win32/", "$INFOZIP_ARCHIVE");
        if (! -f "$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE")
        {
            print "I can't download $INFOZIP_ARCHIVE in order to get UNZIP.EXE\n";
            print "Sorry about that.  I can't go on without UNZIP.EXE\n";
            print LOGFILE "Sorry about that.  I can't go on without UNZIP.EXE\n";
            exit;
        }
    }
}




sub extract_infozip()
{
    mkdir "$TARGETDRIVE\\infozip" or die "Cannot create $TARGETDRIVE\\infozip";
    open BATCH, ">", "$batch";
    print BATCH "$TARGETDRIVE\ncd \\infozip\n$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE\n";
    close BATCH;
    print LOGFILE "\n---------------- start of unzip transaction  ----------------\n";
    print "$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE\n";
    print LOGFILE "$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of unzip transaction  ----------------\n\n";
}



sub prepare_infozip()
{
    # See if the zip has already been extracted.  If not, then do so.
    if (! -f "$TARGETDRIVE\\infozip\\unzip.exe")
    {
        # if archive isn't available, then download it
        if (! -f "$BUGZILLA_TARS_F\\$INFOZIP_ARCHIVE")
        {
            download_infozip();
        }

        extract_infozip();
    }


    if (-f "$TARGETDRIVE\\infozip\\unzip.exe")
    {
        $THEUNZIP="$TARGETDRIVE\\infozip\\unzip.exe";
    }
    else
    {
        print "UNZIP.EXE didn't seem to come out of the archive.\n";
        print "Sorry about that.  I can't go on without UNZIP.EXE\n";
        print LOGFILE "Sorry about that.  I can't go on without UNZIP.EXE\n";
        exit;
    }
}
##############################################################################








##############################################################################
sub download_perl()
{
    print "Info: Great, Now its time to download the big tar.\n";
    print "Info: Umm, by the way this baby is 30 Meg.\n";
    print LOGFILE "Info: Great, Now its time to download the big tar\n";
    ftpget("theoryx5.uwinnipeg.ca", "pub/other", "$UWINNIPEG_ARCHIVE");
    if (! -f "$BUGZILLA_TARS_F\\$UWINNIPEG_ARCHIVE")
    {
        print "Can't get tar for Apache/Perl Integration Project\n";
        print LOGFILE "Can't get tar for Apache/Perl Integration Project\n";
        exit;
    }
    print "Info: Looks like I got $UWINNIPEG_ARCHIVE\n";
    print LOGFILE "Info: Looks like I got $UWINNIPEG_ARCHIVE\n";
}




sub extract_perl()
{
    # The -u option here means update what's already there.
    open BATCH, ">", "$batch";
    print BATCH "$TARGETDRIVE\ncd \\\n";
    print BATCH "$THEUNZIP -u $BUGZILLA_TARS_F\\$UWINNIPEG_ARCHIVE\n";
    close BATCH;

    print LOGFILE "\n---------------- start of unzip transaction  ----------------\n";
    print "Info: $THEUNZIP -u $BUGZILLA_TARS_F\\$UWINNIPEG_ARCHIVE\n";
    print LOGFILE "Info: $THEUNZIP -u $BUGZILLA_TARS_F\\$UWINNIPEG_ARCHIVE\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of unzip transaction  ----------------\n\n";
}


sub prepare_perl()
{
    # See if perl was already installed
    if (! -d "$TARGETDRIVE\\perl\\")
    {
        # See if perl has already been downloaded
        if (! -f "$BUGZILLA_TARS_F\\$UWINNIPEG_ARCHIVE")
        {
            download_perl();
        }

        # Extract Apache and Perl
        extract_perl();
    }


    # Check to make sure that the perl executable was created.
    if (! -f "$TARGETDRIVE\\perl\\bin\\perl.exe")
    {
        print "Apparently, the perl.exe wasn't created from the archive.\n";
        print LOGFILE "Apparently, the perl.exe wasn't created from the archive.\n";
        exit;
    }
}
##############################################################################






##############################################################################

sub download_mysql()
{
    print "Info: Downloading $MYSQL_ARCHIVE with FTP\n";
    print LOGFILE "Info: Downloading $MYSQL_ARCHIVE with FTP\n";

    # Downloads/MySQL-3.23/mysql-3.23.56-win.zip
    # ftp.orst.edu/pub/mysql
    ftpget("mysql.secsup.org", "/pub/software/mysql/Downloads/MySQL-3.23", "$MYSQL_ARCHIVE");
    if (! -f "$BUGZILLA_TARS_F\\$MYSQL_ARCHIVE")
    {
        ftpget("mirror.mcs.anl.gov", "/pub/mysql/Downloads/MySQL-3.23", "$MYSQL_ARCHIVE");
        if (! -f "$BUGZILLA_TARS_F\\$MYSQL_ARCHIVE")
        {
            print "I can't download $MYSQL_ARCHIVE\n";
            print "Sorry about that.  I can't go on without it.\n";
            print LOGFILE "Sorry about that.  I can't go on without $MYSQL_ARCHIVE\n";
            exit;
        }
    }
}


sub extract_mysql()
{
    mkdir "$TARGETDRIVE\\mysql_install";    # or die ...

    open BATCH, ">", "$batch";
    print BATCH "$TARGETDRIVE\ncd \\mysql_install\n$THEUNZIP -u $BUGZILLA_TARS_F\\mysql-3.23.42-win.zip\n";
    close BATCH;

    print LOGFILE "\n---------------- start of unzip transaction  ----------------\n";
    print "Info: $THEUNZIP -u $BUGZILLA_TARS_F\\mysql-3.23.42-win.zip\n";
    print LOGFILE "Info: $THEUNZIP -u $BUGZILLA_TARS_F\\mysql-3.23.42-win.zip\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of unzip transaction  ----------------\n\n";


    if (! -f "$TARGETDRIVE\\mysql_install\\setup.exe")
    {
        print "Apparently, the setup.exe wasn't created from the mysql archive.\n";
        print LOGFILE "Apparently, the setup.exe wasn't created from the mysql archive.\n";
        print "Fatal error.\n";
        print LOGFILE "Fatal error.\n";
        exit;
    }
}


sub install_mysql()
{
    print "Info: Calling $TARGETDRIVE\\mysql_install\\setup.exe\n";
    print LOGFILE "Info: Calling $TARGETDRIVE\\mysql_install\\setup.exe\n";

# The /w doesn't make the installer wait like it should.
    system("$TARGETDRIVE\\mysql_install\\setup.exe /w");

    # Statements following the .exe will execute once setup
    # starts, even though the executable isn't done installing.
    # This is despite throwing in the wait stuff as specified on
    # the InstallShield web site.


    print "Info: $TARGETDRIVE\\mysql_install\\setup.exe is running.\n";
    print LOGFILE "Info: $TARGETDRIVE\\mysql_install\\setup.exe is running.\n";
}



sub prepare_mysql()
{
    # see http://www.mysql.org
    # see http://www.mysql.com

    # see if mysql is already installed
    if (! -f "$TARGETDRIVE\\mysql\\Uninst.isu")
    {
        # see if mysql has already been extracted
        if (! -f "$TARGETDRIVE\\mysql_install\\setup.exe")
        {
            # see if mysql has already been downloaded
            if (! -f "$BUGZILLA_TARS_F\\$MYSQL_ARCHIVE")
            {
                download_mysql();
            }

            # extract mysql from archive to make setup.exe in install directory
            extract_mysql();
        }

        # run setup.exe from install directory
        install_mysql();
    }
}
##############################################################################






##############################################################################
sub download_gunzip()
{
    print "Now its time to download $GUNZIP_ARCHIVE\n";
    print LOGFILE "Now its time to download $GUNZIP_ARCHIVE\n";
    ftpget("tug.ctan.org", "/tex-archive/tools/zip/info-zip/MSDOS", "$GUNZIP_ARCHIVE");
    if (! -f "$BUGZILLA_TARS_F\\$GUNZIP_ARCHIVE")
    {
        print "Can't get tar for gunzip\n";
        print LOGFILE "Can't get tar for gunzip\n";
        exit;
    }
    print "Info: Looks like I got $GUNZIP_ARCHIVE into $BUGZILLA_TARS_F\n";
    print LOGFILE "Info: Looks like I got $GUNZIP_ARCHIVE into $BUGZILLA_TARS_F\n";
}



sub extract_gunzip()
{
    mkdir "$TARGETDRIVE\\gzip" or die "Cannot create $TARGETDRIVE\\gzip";
    open BATCH, ">", "$batch";
    print BATCH "$TARGETDRIVE\ncd \\gzip\n$BUGZILLA_TARS_F\\$GUNZIP_ARCHIVE\n";
    print BATCH "copy gzip.exe gunzip.exe\n";
    close BATCH;
    print LOGFILE "\n---------------- start of unzip transaction  ----------------\n";
    print "$BUGZILLA_TARS_F\\$GUNZIP_ARCHIVE\n";
    print LOGFILE "$BUGZILLA_TARS_F\\$GUNZIP_ARCHIVE\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of unzip transaction  ----------------\n\n";
}

sub prepare_gunzip()
{
    # http://www.gzip.org/gzip124xN.exe
    # ftp://tug.ctan.org/tex-archive/tools/zip/info-zip/MSDOS/gzip124.exe


    # See if the archive has already been extracted.
    if (! -f "$TARGETDRIVE\\gzip\\gunzip.exe")
    {
        # This would be a good place to get $GUNZIP_ARCHIVE
        # if it isn't already in the tar directory
        if (! -f "$BUGZILLA_TARS_F\\$GUNZIP_ARCHIVE")
        {
            download_gunzip();
        }

        # extract the downloaded archive
        extract_gunzip();
    }

    if (-f "$TARGETDRIVE\\gzip\\gunzip.exe")
    {
        $THEGUNZIP="$TARGETDRIVE\\gzip\\gunzip.exe";
    }
    else
    {
        print "GUNZIP.EXE didn't seem to come out of the archive $GUNZIP_ARCHIVE.\n";
        print "Sorry about that.  I can't go on without GUNZIP.EXE\n";
        print LOGFILE "GUNZIP.EXE didn't seem to come out of the archive $GUNZIP_ARCHIVE.\n";
        print LOGFILE "Sorry about that.  I can't go on without GUNZIP.EXE\n";
        exit;
    }
}
##############################################################################








##############################################################################
sub download_bugzilla()
{
    print "Now its time to download bugzilla-$BUGZILLA_VER.tar.gz\n";
    print LOGFILE "Now its time to download bugzilla-$BUGZILLA_VER.tar.gz\n";
    ftpget("ftp.mozilla.org", "/pub/webtools/", "bugzilla-$BUGZILLA_VER.tar.gz");
    if (! -f "$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar.gz")
    {
        print "Can't get tar for bugzilla\n";
        print LOGFILE "Can't get tar for bugzilla\n";
        exit;
    }
    print "Info: Looks like I got bugzilla-$BUGZILLA_VER.tar.gz into $BUGZILLA_TARS_F\n";
    print LOGFILE "Info: Looks like I got bugzilla-$BUGZILLA_VER.tar.gz into $BUGZILLA_TARS_F\n";
}


sub extract_bugzilla()
{
    open BATCH, ">", "$batch";
    print BATCH "$THEGUNZIP < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar.gz ";
    print BATCH "> $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    close BATCH;

    print LOGFILE "\n---------------- start of gunzip transaction  ----------------\n";
    print "Info: $THEGUNZIP <$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar.gz >$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    print LOGFILE "Info: $THEGUNZIP <$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar.gz >$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of gunzip transaction  ----------------\n\n";
}


sub pax_bugzilla()
{
    # PAX is shipped with Windows NT
    # http://support.microsoft.com/support/kb/articles/Q104/4/91.asp
    # This will not execute under Windows 98
    open BATCH, ">", "$batch";
    print BATCH "$TARGETDRIVE\n";
    print BATCH "cd \\\n";
    print BATCH "pax -r < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    close BATCH;

    print LOGFILE "\n---------------- start of pax(tar) transaction  ----------------\n";
    print "Info: pax -r < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    print LOGFILE "Info: pax -r < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of pax(tar) transaction  ----------------\n\n";
}


# This is useless at the moment.
sub untar_bugzilla()
{
    # tar is not shipped with Windows NT nor Windows 98
    # and the one I have doesn't seem to work!

    open BATCH, ">", "$batch";
    print BATCH "tar -x < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    close BATCH;

    print LOGFILE "\n---------------- start of tar transaction  ----------------\n";
    print "Info: tar -x < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    print LOGFILE "Info: tar -x < $BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar\n";
    open(LIST, "$batch | ");    # or die "can't run self-extracting zip archive";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of tar transaction  ----------------\n\n";
}



sub prepare_bugzilla()
{

    # check for untar already performed
    if (! -f "$TARGETDRIVE\\$BUGZILLA_FILES\\localconfig")
    {
        # clean up permanent location
        if (-f "$TARGETDRIVE\\$BUGZILLA_FILES\\*.*")
        {
            unlink "$TARGETDRIVE\\$BUGZILLA_FILES\\*.*" or die "can't unlink $TARGETDRIVE\\$BUGZILLA_FILES\\*.*";
        }
        rmdir "$TARGETDRIVE\\$BUGZILLA_FILES\\";

        # clean up temporary location
        if (-f "$TARGETDRIVE\\bugzilla-$BUGZILLA_VER\\")
        {
            unlink "$TARGETDRIVE\\bugzilla-$BUGZILLA_VER\\*.*" or die "can't unlink $TARGETDRIVE\\bugzilla-$BUGZILLA_VER\\*.*";
            rmdir "$TARGETDRIVE\\bugzilla-$BUGZILLA_VER\\";
        }

        # check for gunzip already performed
        if (! -f "$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar")
        {
            # check for bugzilla already downloaded
            if (! -f "$BUGZILLA_TARS_F\\bugzilla-$BUGZILLA_VER.tar.gz")
            {
                download_bugzilla();
            }
            extract_bugzilla();
        }

        # This will not execute under Windows 98
        pax_bugzilla();
        rename "$TARGETDRIVE\\bugzilla-$BUGZILLA_VER", "$TARGETDRIVE\\$BUGZILLA_FILES";
    }
}
##############################################################################











##############################################################################
# find the location of existing directories
preliminary_work();



# Before getting perl, we're going to need infozip
prepare_infozip();

# Apache and Perl
prepare_perl();

print "Info: I have reached milestone #1.\n\n";
print LOGFILE "Info: I have reached milestone #1.\n\n";

# MYSQL
# [][] perhaps this should be before the prepare_perl() call?
prepare_mysql();

# GZIP/GUNZIP
prepare_gunzip();

# Now use gunzip.exe to unbundle bugzilla
prepare_bugzilla();
##############################################################################






##############################################################################
# These are all fix-ups for issues in the standard releases.
# Applying these fix-ups allows all the packages to be integrated
# into a working whole.

if (1)
{

    # fix up $TARGETDRIVE\apache\conf\httpd.conf
    # Note the other fixup applied with replace.exe
    if (! -f "$TARGETDRIVE\\apache\\conf\\httpd.conf.backup")
    {
        open BATCH, ">", "$BUGZILLA_INSTALL_F\\httpd.conf.add";
        print BATCH "# JSM: I added this at the end of the file\n";
        print BATCH "<IfModule mod_alias.c>\n";
        print BATCH "Alias /bugzilla/ \"$TARGETDRIVE/bugzilla/\"\n";
        print BATCH "<Directory \"$TARGETDRIVE/bugzilla\">\n";
        print BATCH "    Options Indexes FollowSymLinks MultiViews ExecCGI\n";
        print BATCH "    AllowOverride None\n";
        print BATCH "    Order allow,deny\n";
        print BATCH "    Allow from all\n";
        print BATCH "</Directory>\n";
        print BATCH "</IfModule>\n";
        close BATCH;

        open BATCH, ">", "$batch";
        print BATCH "copy $TARGETDRIVE\\apache\\conf\\httpd.conf $TARGETDRIVE\\apache\\conf\\httpd.conf.backup\n";
        print BATCH "copy $TARGETDRIVE\\apache\\conf\\httpd.conf.backup + $BUGZILLA_INSTALL_F\\\\httpd.conf.add $TARGETDRIVE\\apache\\conf\\httpd.conf\n";
        print BATCH "\n";
        close BATCH;

        print LOGFILE "---------------- start of copy transaction  ----------------\n";
        print LOGFILE "copy $TARGETDRIVE\\apache\\conf\\httpd.conf $TARGETDRIVE\\apache\\conf\\httpd.conf.backup\n";
        print LOGFILE "copy $TARGETDRIVE\\apache\\conf\\httpd.conf.backup + $BUGZILLA_INSTALL_F\\\\httpd.conf.add $TARGETDRIVE\\apache\\conf\\httpd.conf\n";

        open(LIST, "$batch | ");
        my ($textline);
        while (defined($textline = <LIST>))
        {
            print LOGFILE $textline;
        }
        close(LIST);
        print LOGFILE "---------------- end of copy transaction  ----------------\n";

        $FILE = "$BUGZILLA_INSTALL_F\\httpd.conf.add";
        unlink "$FILE" if (-f "$FILE");
    }










    #
    #
    # only execute this once
    #
    #
    if (! -f "$TARGETDRIVE\\mysql\\bin\\replace.exe")
    {
        print "$TARGETDRIVE\\mysql\\bin\\replace.exe does not exist.\n";
        print LOGFILE "$TARGETDRIVE\\mysql\\bin\\replace.exe does not exist.\n";
    }
    my($count);
    $count = 0;
    while (! -f "$TARGETDRIVE\\mysql\\bin\\replace.exe")
    {
        $count = $count + 1;
        sleep(1.0);

        if ($count > 5*60)
        {
            die "Fatal error, $TARGETDRIVE\\mysql\\bin\\replace.exe does not exist.";;
        }
    }



#    # JSM: I turned this on in Apache's httpd.conf
#    AddHandler cgi-script .cgi
# need a password in c:\bugzilla\localconfig
# Should this script prompt for the password and use the answer?
# change C:\bugzilla\localconfig
# change $TARGETDRIVE\\$BUGZILLA_FILES\\localconfig
# $db_pass = "";
# $db_pass = "PleaseCharge";
    {
        if (! -f "$BUGZILLA_INSTALL_F\\checksetup.pl")
        {
            open BATCH, ">", "$batch";
            print BATCH "$TARGETDRIVE\n";
            print BATCH "cd \\$BUGZILLA_FILES\n";
            print BATCH "copy checksetup.pl $BUGZILLA_INSTALL_F\\checksetup.pl\n";
            print BATCH "$TARGETDRIVE\\mysql\\bin\\replace.exe /usr/bonsaitools/bin/perl $TARGETDRIVE/perl/bin/perl -- *.cgi *.pl\n";
            print BATCH "$TARGETDRIVE\\mysql\\bin\\replace.exe /usr/bonsaitools/bin/perl $TARGETDRIVE/perl/bin/perl -- Bug.pm\n";
            print BATCH "$TARGETDRIVE\\mysql\\bin\\replace.exe getgrnam(\$my_webservergroup) 8 -- checksetup.pl\n";
            print BATCH "$TARGETDRIVE\\mysql\\bin\\replace.exe \"#AddHandler cgi-script .cgi\" \"AddHandler cgi-script .cgi\" -- $TARGETDRIVE\\apache\\conf\\httpd.conf\n";
            print BATCH "$TARGETDRIVE\\mysql\\bin\\replace.exe \"\$db_pass = \" \"\$db_pass = 'PleaseCharge' .\" -- $TARGETDRIVE\\$BUGZILLA_FILES\\localconfig\n";

            close BATCH;
            print LOGFILE "\n---------------- start of patch transaction  ----------------\n";
            open(LIST, "$batch | ");    # or die "can't run perl to patch checksetup.pl";
            my ($textline);
            while (defined($textline = <LIST>))
            {
                print LOGFILE $textline;
            }
            close(LIST);
            print LOGFILE "---------------- end of patch transaction  ----------------\n\n";
        }
    }





    # fix up  my.cnf  for mysql
    if (! -f "C:\\my.cnf")
    {
        open BATCH, ">", "$BUGZILLA_INSTALL_F\\my.cnf.add";
        print BATCH "[mysqld]\n";
        print BATCH "skip-networking\n";
        print BATCH "\n";
        close BATCH;

        print LOGFILE "copy $TARGETDRIVE\\mysql\\my-example.cnf + $BUGZILLA_INSTALL_F\\my.cnf.add C:\\my.cnf\n";
        system "copy $TARGETDRIVE\\mysql\\my-example.cnf + $BUGZILLA_INSTALL_F\\my.cnf.add C:\\my.cnf";

        $FILE = "$BUGZILLA_INSTALL_F\\my.cnf.add";
        unlink "$FILE" if (-f "$FILE");
    }




    print LOGFILE "Info: Creating $BUGZILLA_INSTALL_F\\start_apache.bat\n";
    open BATCH, ">", "$BUGZILLA_INSTALL_F\\start_apache.bat";
    print BATCH "\@echo off\n";
    print BATCH "call $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    print BATCH "\n";
    print BATCH "rem start the web server\n";
    print BATCH "$TARGETDRIVE\n";
    print BATCH "cd \\apache\n";
    print BATCH "start Apache.exe -k start\n";
    print BATCH "$INSDRIVE\n";   # is this necessary?
    print BATCH "\n";
    close BATCH;

    print LOGFILE "Info: Creating $BUGZILLA_INSTALL_F\\start_mysql.bat\n";
    open BATCH, ">", "$BUGZILLA_INSTALL_F\\start_mysql.bat";
    print BATCH "\@echo off\n";
    print BATCH "call $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    print BATCH "\n";
    print BATCH "winmysqladmin\n";
    print BATCH "\n";
    close BATCH;


    print LOGFILE "Info: Creating $BUGZILLA_INSTALL_F\\checksetup.bat\n";
    open BATCH, ">", "$BUGZILLA_INSTALL_F\\checksetup.bat";
    print BATCH "\@echo on\n";
    print BATCH "call $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    print BATCH "\n";
    print BATCH "$TARGETDRIVE\n";
    print BATCH "cd \\$BUGZILLA_FILES\n";
    print BATCH "perl checksetup.pl\n";
    print BATCH "\n";
    close BATCH;

    print LOGFILE "Info: Creating $BUGZILLA_INSTALL_F\\uninstall.bat\n";
    open BATCH, ">", "$BUGZILLA_INSTALL_F\\uninstall.bat";
    print BATCH "\@echo off\n";
    print BATCH "echo This will really remove all Apache, Perl, and Bugzilla files ...\n";
    print BATCH "echo Shut down everything before continueing ...\n";
    print BATCH "pause\n";
    print BATCH "\@echo on\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\$BUGZILLA_FILES\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\apache\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\readmes\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\perl\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\openssl\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\infozip\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\gzip\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\mysql_install\n";
    print BATCH "rem Are you sure about this?\n";
    print BATCH "rmdir /s/q $TARGETDRIVE\\.cpan\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\start_apache.bat\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\start_mysql.bat\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\checksetup.bat\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\checksetup.pl\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\httpd.conf.add\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\my.cnf.add\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\install.log\n";
    print BATCH "del $BUGZILLA_INSTALL_F\\install.old.log\n";


    print BATCH "\@echo off\n";
    print BATCH "rem I should remove these, because the MYSQL uninstall won't delete them.\n";
    print BATCH "if exist C:\\my_cnf.bak del C:\\my_cnf.bak\n";
    print BATCH "if exist C:\\my.cnf del C:\\my.cnf\n";
    print BATCH "\n";
    print BATCH "\n";
    print BATCH "rem This would be a good point to drop/delete the database.\n";
    print BATCH "echo/\n";
    print BATCH "echo/\n";
    print BATCH "echo/\n";
    print BATCH "echo Now you can manually uninstall MYSQL\n";
    print BATCH "pause\n";
    print BATCH "\n";
    print BATCH "\n";
    close BATCH;

    unlink ($batch) if (-f "$batch");

    print "\nInfo: I have reached milestone #2.\n\n";
    print LOGFILE "\nInfo: I have reached milestone #2.\n\n";
}
##############################################################################






##############################################################################
#
# This subroutine patches one .cgi or .pl file named by the caller.
# This code isn't used today.
#
sub patch_cgi($)
{
    my($BACKUP, $FILE);
    $FILE = shift;
    $BACKUP = "$FILE.jsm";

    unlink ($BACKUP) if (-f "$BACKUP");
    rename ("$FILE", "$BACKUP") or die "Can't rename $FILE to $BACKUP";

    open(OLDSCRIPT, "<", "$BACKUP") or die "can't read $BACKUP";
    open(NEWSCRIPT, ">", "$FILE") or die "can't write $FILE";

    my ($textline);
    while (defined($textline = <OLDSCRIPT>))
    {
        # This patches all the shebang lines
        $textline =~ s|^#!/usr[/bonsaitools]*/bin/perl|#!$TARGETDRIVE/perl/bin/perl|;

        # This patches checksetup.pl, line 729 or so
        #    my $webservergid = getgrnam($my_webservergroup);
        # to
        #    my $webservergid = 8;
        $textline =~ s/getgrnam[\(][\$]my_webservergroup[\)]/8/;

        print NEWSCRIPT $textline;
    }
    close(OLDSCRIPT);
    close(NEWSCRIPT);
}
##############################################################################





##############################################################################
# Can't setup paths from here, must use batch file.
   print "Info: path is $ENV{PATH}\n\n";
   print LOGFILE "Info: path is $ENV{PATH}\n\n";

    if (! -d "$TARGETDRIVE\\TEMP")
    {
        print "Info: mkdir $TARGETDRIVE\\TEMP\n";
        print LOGFILE "Info: mkdir $TARGETDRIVE\\TEMP\n";
        mkdir("$TARGETDRIVE\\TEMP") or die "Cannot create $TARGETDRIVE\\TEMP";
    }


    # name of temporary file for batch script
    $onestepmodules = "$BUGZILLA_INSTALL_F\\onestepmodules.bat";


    print LOGFILE "Info: Creating $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    open BATCH, ">", "$BUGZILLA_INSTALL_F\\onestep.paths.bat";
    print BATCH "\@echo off\n";
    print BATCH "if not exist $TARGETDRIVE\\temp\\*.* mkdir $TARGETDRIVE\\temp\\n";
    print BATCH "set TEMP=$TARGETDRIVE\\TEMP\n";
    print BATCH "\n";
    print BATCH 'if not "%OS%" == "Windows_NT" goto skipWinNT\n';
    print BATCH "rem yank stuff off the path\n";
    print BATCH "rem This means that this batch file can be called twice.\n";
    print BATCH "path \%PATH:$TARGETDRIVE\\perl\\bin;=\%\n";
    print BATCH "path \%PATH:$TARGETDRIVE\\openssl\\bin;=\%\n";
    print BATCH "path \%PATH:$TARGETDRIVE\\perl;=\%\n";
    print BATCH "path \%PATH:$TARGETDRIVE\\mysql\\bin;=\%\n";
    print BATCH ":skipWinNT\n";
    print BATCH "\n";
    print BATCH "rem Add the correct directories onto the path\n";

    #
    # For some bizarre reason, this path statement doesn't take effect
    # under Windows 98.  It does under NT ...
    #
    print BATCH "path $TARGETDRIVE\\perl\\bin;$TARGETDRIVE\\openssl\\bin;$TARGETDRIVE\\mysql\\bin;\%PATH\%\n";

    print BATCH "\n";
    print BATCH "rem Don't think I need these\n";
    print BATCH "rem set SITELIB=\%PATH\%\n";
    print BATCH "set PERLDIR=\%PATH\%\n";
    print BATCH "\n";
    close BATCH;


    print LOGFILE "Info: Creating $onestepmodules\n";
    open BATCH, ">", "$onestepmodules";
    print BATCH "\@echo off\n";
    print BATCH "call $BUGZILLA_INSTALL_F\\onestep.paths.bat\n";
    print BATCH "\n";
    print BATCH "$TARGETDRIVE\ncd \\\n";
    print BATCH "perl \"$BUGZILLA_INSTALL_F\\onestepmodules.pl\" $BUGZILLA_INSTALL_F\n";
    close BATCH;


if (1)
{
    system($onestepmodules);
}
else
{
    print LOGFILE "\n---------------- start of onestepmodules transaction  ----------------\n";
    open(LIST, "$onestepmodules |");    # or die "can't run";
    my ($textline);
    while (defined($textline = <LIST>))
    {
        print LOGFILE $textline;
    }
    close(LIST);
    print LOGFILE "---------------- end of onestepmodules transaction  ----------------\n\n";
}
    $FILE = "$onestepmodules";
    unlink "$FILE" if (-f "$FILE");

##############################################################################










##############################################################################
# This section would be about getting stuff to execute.
if (1)
{

    # Start up Apache with "start" command; and then return here.
    system ("$BUGZILLA_INSTALL_F\\start_apache.bat");
    # wait a moment for Apache to completely start
    sleep(1.0);



    # Don't try to launch iexplore.exe via the .html extension, because
    # the system hangs eventually (at least under Windows 4.0 SP6a it does)
    #  http://127.0.0.1/bugzilla/index.html
    # Go find the executable ...
    open(LIST, "dir $TARGETDRIVE\\iexplore.exe/s/b | ");
    my ($textline);
    if (defined($textline = <LIST>))
    {
        close(LIST);
        $textline =~ s/\n//;

        #   "C:\Program Files\Plus!\Microsoft Internet\IEXPLORE.EXE" 127.0.0.1/bugzilla/index.html
        system( "start \"bugzilla\" \"$textline\" 127.0.0.1/bugzilla/index.html " );
    }
    else
    {
        close(LIST);
    }

}
##############################################################################



print "Info: What's next?\n";

exit;


__END__

=head1 NAME

onestep - install bugzilla in one step

=head1 SYNOPSIS

	C:\bugzilla_install> onestep.bat

=head1 DESCRIPTION

This program installs everything you need to run bugzilla.
It looks around a little to see what you already have installed,
and provides what is missing.

=head1 COMPONENTS

The following components are installed for you:

=over

=item Apache/Perl Integration Project

From theoryx5.uwinnipeg.ca

=item MYSQL

From http://prdownloads.sourceforge.net

=item gunzip

From ftp://tug.ctan.org

=item INFOZIP

From ftp.info-zip.org



=back


=head1 AUTHOR

John Muczynski

=cut

__END__
:endofperl
