#
#
# onestepmodules.pl
#

use Getopt::Long;
use File::Basename;
use Config;
use strict;
use warnings;

use PPM;

$PPM::VERSION = "2.1.6";

print "Now executing 'onestepmodules' ...\n\n";

sub do_one($$)
{
    my $package = shift;
    my $location = shift;
    my $doit = 0;

    print "Verifying package '$package'...\n";

    #    , "location" => $location
    my $ok = VerifyPackage("package" => $package);
    # returns undef for error case
    if (! defined $ok)
    {
        print "Error verifying package '$package': $PPM::PPMERR\n";
        $doit = 1;
    }
    else
    {
        # 1=update needed
        $doit = $ok;
    }

    if ($doit == 1)
    {
        print "Installing package '$package'...\n";

        #    , "location" => $location
        if(!InstallPackage("package" => $package))
        {
            print "Error installing package '$package': $PPM::PPMERR\n";
        }
        else
        {
            # it would be nice to say what the version of the package is...
            print "Installed package '$package'\n";
        }
    }
    else
    {
        print "Update for '$package' not needed.\n";
    }

}

# version 1.35
#do_one("DBI", "http://www.cpan.org");
#system "ppm install DBI";
#423364 bytes
do_one("DBI", "");

#system "ppm install DBD-Mysql";
#http://www.cpan.org/authors/id/J/JW/JWIED/DBD-mysql-2.1026.tar.gz
do_one("DBD-Mysql", "");

# version 1.14
do_one("TimeDate", "");
# "http://www.cpan.org/authors/id/G/GB/GBARR/TimeDate-1.14.tar.gz");
# version 1.16 seems better

#system "ppm install Chart";
#system "ppm install Date-Calc";
#system "ppm install Date-Manip";
#system "ppm install GD";
do_one("Chart", "");
do_one("Date-Calc", "");
do_one("Date-Manip", "");
do_one("GD", "");


#C:\bugzilla>perl checksetup.pl
#
#Checking perl modules ...
#Checking for             DBI (v1.13)   ok: found v1.35
#Checking for    Data::Dumper (any)     ok: found v2.102
#Checking for      DBD::mysql (v1.2209) ok: found v2.1026
#Checking for     Date::Parse (any)     ok: found v2.24
#Checking for       CGI::Carp (any)     ok: found v1.24
#
#The following Perl modules are optional:
#Checking for              GD (v1.19)   ok: found v2.07
#Checking for     Chart::Base (v0.99)   Argument "^A" isn't numeric in numeric lt
# (<) at checksetup.pl line 173 (#1)
#    (W numeric) The indicated string was fed as an argument to an operator
#    that expected a numeric value instead.  If you're fortunate the message
#    will identify which operator was so unfortunate.
#
# found unknown version
#Checking for     XML::Parser (any)     ok: found v2.31
#
#If you you want to see graphical bug dependency charts, you may install
#the optional libgd and the Perl modules GD-1.19 and Chart::Base-0.99b, e.g. by
#running (as root)
#
#   perl -MCPAN -e'install "LDS/GD-1.19.tar.gz"'
#   perl -MCPAN -e'install "N/NI/NINJAZ/Chart-0.99b.tar.gz"'
#
#Checking user setup ...
#The getgrnam function is unimplemented at checksetup.pl line 706 (#2)
#    The function indicated isn't implemented on this architecture, according
#    to the probings of Configure.
#
#Uncaught exception from user code:
#        The getgrnam function is unimplemented at checksetup.pl line 706.





#C:\bugzilla>perl -MCPAN
#install "Date::Parse"
#^Z
#CPAN: Storable loaded ok
#CPAN: LWP::UserAgent loaded ok
#Fetching with LWP:
#  ftp://theoryx5.uwinnipeg.ca/pub/CPAN/authors/01mailrc.txt.gz
#Going to read C:\.cpan\sources\authors\01mailrc.txt.gz
#CPAN: Compress::Zlib loaded ok
#Fetching with LWP:
#  ftp://theoryx5.uwinnipeg.ca/pub/CPAN/modules/02packages.details.txt.gz
#Going to read C:\.cpan\sources\modules\02packages.details.txt.gz
#  Database was generated on Tue, 17 Jun 2003 12:14:40 GMT
#CPAN: HTTP::Date loaded ok
#
#  There's a new CPAN.pm version (v1.70) available!
#  [Current version is v1.63]
#  You might want to try
#    install Bundle::CPAN
#    reload cpan
#  without quitting the current session. It should be a seamless upgrade
#  while we are running...
#
#
#





##############################################################################
# Everything is installed.  This section configures and checks the system.
if (1)
{

# [][] Should I prompt the user to start up mysql?

    # mysql.exe <"quit" can be executed in order to see if mysql is running
    # but it has a long timeout for the "not running" case.



    my ($BUGZILLA_INSTALL_F);

    $BUGZILLA_INSTALL_F = $ARGV[0];

# during debug
if (0)
{
    if ($BUGZILLA_INSTALL_F ne "E:\\bugzilla_install")
    {
        print "ARGV[0] is \"$ARGV[0]\"\n";
    }
}

    # perl checksetup.pl
    print "Info: interpret checksetup.pl\n";
#    print LOGFILE "Info: interpret checksetup.pl\n";
    system "$BUGZILLA_INSTALL_F\\checksetup.bat";

    print "Info: interpret checksetup.pl a second time\n";
#    print LOGFILE "Info: interpret checksetup.pl a second time\n";
    system "$BUGZILLA_INSTALL_F\\checksetup.bat";

}
##############################################################################

